local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	login_callback = nil,
	is_init = false,
	force_logout = false,
	is_login_verify_ing = false,
	login_verify_url = "cls.cp01.youyannet.com/hi9/login_verify.php",
	pay_callback_url = "cls.cp01.youyannet.com/hi9/pay.php",
	uid = "",
}

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "hi9"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "hi9_" .. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[106]
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "big_logo_jphx_hi3"
end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return "loading_bg_empty"
end

function AgentAdapter:LoginCallback(result)
	Log("LoginCallback:result=" .. result)
	local json_obj = cjson.decode(result)
	if nil == json_obj or json_obj.uid == nil or nil == json_obj.sid then return end
	self.uid = json_obj.uid
	self.login_callback(self:GetPlatName(), json_obj.sid)
end

function AgentAdapter:Login(callback)
	self.login_callback = callback
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end

	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))
end

function AgentAdapter:SwitchAccount(callback)
	self.login_callback = callback
	agent_helper:Logout()
end

function AgentAdapter:LogoutCallback(result)
	if "true" == result then
		self.uid = ""
		if not LoginController.Instance:AgentLoginViewIsOpen() then
			ReStart()
		end
	end
	return true
end

function AgentAdapter:Logout()
	self.force_logout = true
	agent_helper:Logout()
end

function AgentAdapter:UIEventCallback(event)
	if "open" == event then
		--self:ShowFloatButton()
	elseif "close" == event then
		--self:ShowFloatButton()
	end
	return true
end

function AgentAdapter:ShowFloatButton()
	agent_helper:ShowFloatButton(70, 30, true)
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)

	local info = {}
	info.app_id = 3077868
	info.buy_amount = 1
	info.cp_order_id = server_id .. "_" .. self:GetOpenId() .. "_" .. os.time()
	info.create_time = os.time()
	info.pay_type = 0
	info.product_body = ""
	info.product_id = 0
	info.product_per_price = tostring(amount) .. ".0"
	info.product_subject = "购买".. (amount * 10) .. "个元宝"
	info.product_unit = "个"
	info.total_price = tostring(amount) .. ".0"
	info.uid = self:GetOpenId()
	info.user_info = ""

	local appSecret = "6Sd2XsdGno1zSJBbwm8HEyD09S3zqh4B"

	local sign_str = "app_id=" .. info.app_id
	sign_str = sign_str .. "&buy_amount=" .. info.buy_amount
	sign_str = sign_str .. "&cp_order_id=" .. info.cp_order_id
	sign_str = sign_str .. "&create_time=" .. info.create_time
	sign_str = sign_str .. "&pay_type=" .. info.pay_type
	sign_str = sign_str .. "&product_body=" .. info.product_body
	sign_str = sign_str .. "&product_id=" .. info.product_id
	sign_str = sign_str .. "&product_per_price=" .. info.product_per_price
	sign_str = sign_str .. "&product_subject=" .. info.product_subject
	sign_str = sign_str .. "&product_unit=" .. info.product_unit
	sign_str = sign_str .. "&total_price=" .. info.total_price
	sign_str = sign_str .. "&uid=" .. info.uid
	sign_str = sign_str .. "&user_info=" .. info.user_info
	sign_str = sign_str .. ":" .. appSecret

	info.sign = UtilEx:md5Data(sign_str)
	info.sign_type = "md5"
	agent_helper:Pay(cjson.encode(info), callback)
end

function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	local data = {["roleId"] = role_id, ["roleName"] = role_name, ["roleLevel"] = role_level, ["zoneId"] = zone_id, ["zoneName"] = zone_name}
	agent_helper:SubmitExtendData("loginGameRole", data)
end

function AgentAdapter:EnterUserCenter()
	agent_helper:EnterUserCenter()
end

agent_helper:SetLogoutCallback(LUA_CALLBACK(AgentAdapter, AgentAdapter.LogoutCallback))
agent_helper:SetUIEventCallback(LUA_CALLBACK(AgentAdapter, AgentAdapter.UIEventCallback))

--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end
